#include <windows.h>
#include <stdio.h>
#include <WinCred.h>

void showAll()
{
	if( getenv( "credmgr_domain" ) == NULL )
	{
		DWORD count;
		PCREDENTIAL * creds;
		DWORD i;
		if( CredEnumerate( NULL, 0, &count, &creds ) )
		{
			for( i = 0; i < count; i++ ){
				printf( "ID:[%s]\n", creds[i]->UserName  );
			}
			CredFree( creds );
		}
	}
	else
	{
		DWORD count;
		PCREDENTIAL * creds;
		DWORD i;
		CREDENTIAL_TARGET_INFORMATION svr = {0};
		svr.NetbiosDomainName = getenv( "credmgr_domain" );
		if( CredReadDomainCredentials( &svr, CRED_CACHE_TARGET_INFORMATION, &count, &creds ) )
		{
			for( i = 0; i < count; i++ ){
				printf( "ID:[%s]\n", creds[i]->UserName  );
			}
			CredFree( creds );
		}
	}
}

void deleteID( const char * ID )
{
	if( getenv( "credmgr_domain" ) == NULL )
	{
		DWORD count;
		PCREDENTIAL * creds;
		DWORD i;
		if( CredEnumerate( NULL, 0, &count, &creds ) )
		{
			for( i = 0; i < count; i++ ){
				if( 0==strcmp(creds[i]->UserName,ID) ){
					if( CredDelete( ID, creds[i]->Type, 0 ) ){
						printf( "Delete ID:[%s] OK!\n", creds[i]->UserName  );
					}
					else{
						printf( "Failed to delete ID:[%s]!\n", creds[i]->UserName  );
					}
				}
			}
			CredFree( creds );
		}
	}
	else
	{
		DWORD count;
		PCREDENTIAL * creds;
		DWORD i;
		CREDENTIAL_TARGET_INFORMATION svr = {0};
		svr.NetbiosDomainName = getenv( "credmgr_domain" );
		if( CredReadDomainCredentials( &svr, CRED_CACHE_TARGET_INFORMATION, &count, &creds ) )
		{
			for( i = 0; i < count; i++ ){
				if( 0==strcmp(creds[i]->UserName,ID) ){
					if( CredDelete( ID, creds[i]->Type, 0 ) ){
						printf( "Delete ID:[%s] OK!\n", creds[i]->UserName  );
					}
					else{
						printf( "Failed to delete ID:[%s]!\n", creds[i]->UserName  );
					}
				}
			}
			CredFree( creds );
		}
	}
}

void main( int argc, char * argv[] )
{
	if( argc == 1 ){
		showAll();
	}
	else{
		int ic = 1;

		if( argc >= ic+1 && 0==strcmp( argv[ic], "/?" ) ){
			printf( "Usage: %s        -->show all ID\n", argv[0] );
			printf( "Usage: %s /?     -->show help\n", argv[0] );
			printf( "Usage: %s /d ID  -->delete ID\n", argv[0] );
		}
		else if( argc >= ic+1 && 0==strcmp( argv[ic], "/d" ) ){
			ic++;
			if( argc >= ic+1 && argv[ic][0] ){
				deleteID( argv[ic] );
			}
			else{
				printf( "\"ID\" parameterTo is needed\n"
						"To delete ID, use: %s /d ID\n"
						"To get help, use: %s /?\n"
						,argv[0],argv[0],argv[0] );
			}
		}
	}
}

